;GOBANG
;by A.N. Morton
;from ZX Computing Dec'84/Jan'85
;Machine Code routines

0E00      LD C,0
3A007D    LD A,(32000)    ;A = 3 or 7
21117D    LD HL,32017     ;First address of matrix
0681      LD B,129        ;Count 129
BE        CP (HL)         ;Search for the first stone
2804      JRZ,+4          ;Jump if found
23        INC HL          ;Next address
10FA      DJNZ,-6         ;Jump back to search
C9        RET             ;Return to BASIC; BC = 0

C5        PUSH BC         ;Save count
E5        PUSH HL         ;Save address of first stone
ED4B017D  LD BC,(32001)   ;B=(32002), C=(32001)
23        INC HL          ;Next address horiz-line
86        ADD A,(HL)      ;Line summing
10FC      DJNZ,-4         ;Jump to next address
A7        AND A           ;Clear C-flag
B9        CP C            ;Line found?
2005      JRNZ,+5         ;Jump if not found
E1        POP HL
C1        POP BC          ;B = start of line
0E01      LD C,1          ;C = 1 horiz-line
C9        RET             ;Return to BASIC

E1        POP HL          ;First stone address
E5        PUSH HL         ;Save address
3A007D    LD A,(32000)    ;A = 3 or 7
ED4B017D  LD BC,(32001)   ;B = line length, C = line sum
110F00    LD DE,15        ;Vertical line step
19        ADD HL,DE       ;Next address on line
86        ADD A,(HL)      ;Line summing
10F9      DJNZ,-7         ;Jump to next address
A7        AND A           ;Clear C-flag
B9        CP C            ;Line found?
2005      JRNZ,+5         ;Jump if not
E1        POP HL
C1        POP BC
0E0F      LD C,15         ;C = 15 for vertical line
C9        RET             ;To BASIC

E1        POP HL
E5        PUSH HL
3A007D    LD A,(32000)
ED4B017D  LD BC,(32001)
111000    LD DE,16        ;R-diagonal line step
19        ADD HL,DE       ;Next address on line
86        ADD A,(HL)      ;Line sum
10F9      DJNZ,-7
A7        AND A
B9        CP C            ;Line found?
2005      JRNZ,+5
E1        POP HL
C1        POP BC
0E10      LD C,16         ;C = 16 for R-diag line
C9        RET             ;To BASIC

E1        POP HL
E5        PUSH HL
111C00    LD DE,28
19        ADD HL,DE
7E        LD A,(HL)
ED4B017D  LD BC,(32001)
A7        AND A
110E00    LD DE,14        ;L-diagonal step
ED52      SBC HL,DE       ;Next address up line
86        ADD A,(HL)      ;Line sum
10F8      DJNZ,-8         ;Next address
B9        CP C            ;Line found?
2005      JRNZ,+5         ;Jump if not
E1        POP HL
C1        POP BC
0E0E      LD C,14         ;C = 14 for L-diag line
C9        RET             ;To BASIC

E1        POP HL
C1        POP BC
3A007D    LD A,(32000)
1894      JR,-108         ;Jump back to search
0000      DEFB 00,00

0681      LD B,129        ;Set counter to 129
21117D    LD HL,32017     ;First address of matrix
3600      LD (HL),0       ;Set contents to zero
23        INC HL          ;Next address
10FB      DJNZ,-5         ;Jump back to set
C9        RET
0000      DEFB 00,00

2AF17C    LD HL,(31985)
ED4BF37C  LD BC,(31987)
18E3      JR,-29          ;Jump back to search
